From iris.proofmode Require Export proofmode.
From diaframe Require Export proofmode_base symb_exec.spec_notation.
From diaframe.symb_exec Require Import defs weakestpre.
From diaframe.lib Require Import iris_hints.
From iris_simp_lang Require Import simp.
From iris.algebra Require Import dfrac.

Open Scope expr_scope.

Section instances.
  Context `{!simpGS Σ}.

  Global Instance pure_spec (e : expr) φ n e' :
    PureExec φ n e e' →
    SPEC {{ ⌜φ⌝ }} e {{ [▷^n] RET e'; True }}.
  Proof.
    intros. iStepsS.
    rewrite -lifting.wp_pure_step_later //.
    iStepsS.
  Qed.

  Global Instance faa_spec (l : loc) (z : Z) E1 E2 :
    SPEC ⟨E1, E2⟩ (z' : Z), {{ l ↦ #z' }} FAA #l #z {{ RET #z'; l ↦ #(z' + z) }}.
  Proof. iStepsS. iApply (wp_faa with "[$]"); iStepsS. Qed.

  Global Instance load_spec (l : loc) E1 E2 :
    SPEC ⟨E1, E2⟩ (dq : dfrac) (v : val), {{ l ↦{dq} v }} ! #l {{ RET v; l ↦{dq} v }}.
  Proof. iStepsS. iApply (wp_load with "H1"); iStepsS. Qed.

  Global Instance ref_spec (v : val) :
    SPEC {{ True }} ref v {{ (l : loc), RET #l; l ↦ v }}.
  Proof. iStepsS. iApply wp_alloc; iStepsS. Qed.

  (* More hints will be necessary for when goal and hypothesis dfrac are not equal *)
  Global Instance mapsto_val_eq (l : loc) dq v1 v2 :
    HINT l ↦{dq} v1 ✱ [- ; ⌜v1 = v2⌝] ⊫ [id]; l ↦{dq} v2 ✱ [⌜v1 = v2⌝] | 55.
  Proof. iStepsS. Qed.
End instances.

Global Hint Extern 4 (ReshapeExprAnd (language.expr simp_lang) ?e ?K ?e' ?TC) => 
  tactics.reshape_expr e ltac:(fun K' e'' =>
      unify K (fill K'); unify e' e'';
      notypeclasses refine (ConstructReshape e (fill K') e'' _ (eq_refl) _); iSolveTC)
     : typeclass_instances.

Global Hint Extern 4 (@eq val _ _) => 
  progress f_equal; pure_solver.trySolvePureEq : solve_pure_eq_add.

Global Hint Extern 4 (@eq base_lit _ _) => 
  progress f_equal; pure_solver.trySolvePureEq : solve_pure_eq_add. 

